var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/HighlightInput/index.tsx
var HighlightInput_exports = {};
__export(HighlightInput_exports, {
  default: () => HighlightInput_default
});
module.exports = __toCommonJS(HighlightInput_exports);
var import_react = __toESM(require("react"));
var import_useControlValue = __toESM(require("../hooks/useControlValue"));
var import_index = require("./index.scss");
var import_utils = require("./utils");
function trigger(el, type) {
  const e = document.createEvent("HTMLEvents");
  e.initEvent(type, true, true);
  el.dispatchEvent(e);
}
var RichTextInput = (0, import_react.forwardRef)((props, ref) => {
  const {
    disabled,
    placeholder,
    className = "",
    editorClassName = "",
    keywordsStyle,
    onFocus,
    onBlur,
    prefix,
    suffix
  } = props;
  const [value, setValue] = (0, import_useControlValue.default)(props);
  const editorRef = (0, import_react.useRef)(null);
  const isComposing = (0, import_react.useRef)(false);
  const range = (0, import_react.useRef)();
  const handleChange = (value2) => {
    var _a, _b;
    range.current = (_b = (_a = window.getSelection()) == null ? void 0 : _a.getRangeAt(0)) == null ? void 0 : _b.cloneRange();
    setValue(value2);
  };
  const getKeywordsStyle = (keywords) => {
    const rootStyle = editorRef.current && getComputedStyle(editorRef.current);
    const defaultStyle = {
      fontSize: rootStyle == null ? void 0 : rootStyle.fontSize,
      fontFamily: rootStyle == null ? void 0 : rootStyle.fontFamily,
      color: rootStyle == null ? void 0 : rootStyle.color,
      wordBreak: "keep-all",
      whiteSpace: "nowrap",
      backgroundColor: "rgba(194, 224, 255, 0.5)",
      lineHeight: rootStyle == null ? void 0 : rootStyle.lineHeight,
      textAlign: "center"
      // padding: '1px 0 1px 0'
    };
    let styles = {
      ...defaultStyle
    };
    if (typeof keywordsStyle === "function") {
      styles = {
        ...styles,
        ...keywordsStyle == null ? void 0 : keywordsStyle(defaultStyle, keywords)
      };
    } else {
      styles = {
        ...styles,
        ...keywordsStyle
      };
    }
    return styles;
  };
  const handlePaste = (0, import_react.useCallback)(
    (e) => {
      e.preventDefault();
      const { clipboardData } = e;
      let pastedText = (clipboardData || window.clipboardData).getData(
        "text/html"
      );
      if (pastedText) {
        pastedText = pastedText.replace(/[\r\n]/g, "");
        const regex = /(<(meta|br).*?>)|(\sstyle=".*?")|(\n)/gi;
        pastedText = pastedText.replace(regex, "");
        let pastedRichValue = (0, import_utils.convertHTMLStringToRichValue)(pastedText);
        const includeKeywords = pastedRichValue.find(
          (item) => typeof item !== "string"
        );
        if (!includeKeywords) {
          pastedText = (0, import_utils.htmlEncode)(
            (clipboardData || window.clipboardData).getData(
              "text/plain"
            )
          );
          pastedRichValue = (0, import_utils.convertHTMLStringToRichValue)(pastedText);
        }
        if (editorRef.current) {
          pastedText = (0, import_utils.convertRichValueToHTMLString)(
            pastedRichValue,
            getKeywordsStyle
          );
          document.execCommand("insertHTML", false, pastedText);
          const richValue = (0, import_utils.convertHTMLStringToRichValue)(
            editorRef.current.innerHTML
          );
          handleChange(richValue);
        }
      }
      return false;
    },
    [setValue]
  );
  const handleKeydown = (0, import_react.useCallback)(
    (e) => {
      if (e.key === "Enter") {
        e.preventDefault();
      }
    },
    []
  );
  (0, import_react.useImperativeHandle)(ref, () => {
    return {
      insertKeywords: (keywords) => {
        var _a;
        if (!editorRef.current) {
          return;
        }
        const keywordsNodeString = (0, import_utils.makeKeywordsNodeString)(
          keywords,
          getKeywordsStyle
        );
        (_a = editorRef.current) == null ? void 0 : _a.focus();
        (0, import_utils.insertHtmlAtCaret)(keywordsNodeString, range.current);
        const richValue = (0, import_utils.convertHTMLStringToRichValue)(
          editorRef.current.innerHTML
        );
        handleChange(richValue);
      }
    };
  });
  const handleSelectCapture = (0, import_react.useCallback)(() => {
    var _a, _b;
    range.current = (_b = (_a = window.getSelection()) == null ? void 0 : _a.getRangeAt(0)) == null ? void 0 : _b.cloneRange();
  }, []);
  const clsPrefix = "c-highlight";
  (0, import_react.useEffect)(() => {
    var _a;
    if (!editorRef.current) {
      return;
    }
    const htmlString = (0, import_utils.convertRichValueToHTMLString)(value, getKeywordsStyle);
    const innerHtmlString = (_a = editorRef.current.innerHTML) == null ? void 0 : _a.replace(
      /&nbsp;/g,
      " "
    );
    const innerValue = (0, import_utils.convertHTMLStringToRichValue)(innerHtmlString) || [];
    let isEqual = true;
    if (innerValue.length !== (value == null ? void 0 : value.length)) {
      isEqual = false;
    } else {
      for (let index = 0; index < innerValue.length; index++) {
        const element = innerValue[index];
        const receivedElement = value == null ? void 0 : value[index];
        if (typeof element === "string" || typeof receivedElement === "string") {
          if (element !== receivedElement) {
            isEqual = false;
            break;
          }
        } else {
          if (element.value !== receivedElement.value && element.label !== receivedElement.label) {
            isEqual = false;
          }
        }
      }
    }
    if (!isEqual) {
      editorRef.current.innerHTML = htmlString;
    }
  }, [value]);
  (0, import_react.useEffect)(() => {
    const el = editorRef.current;
    const customEventName = "input";
    const handleCompositionStart = () => {
      isComposing.current = true;
    };
    const handleCompositionEnd = (e) => {
      if (!isComposing.current)
        return;
      isComposing.current = false;
      trigger(e.target, customEventName);
    };
    const handleInput = (e) => {
      if (isComposing.current)
        return;
      const innerHTML = e.currentTarget.innerHTML;
      const richValue = (0, import_utils.convertHTMLStringToRichValue)(innerHTML);
      handleChange(richValue);
    };
    el == null ? void 0 : el.addEventListener("compositionstart", handleCompositionStart);
    el == null ? void 0 : el.addEventListener("compositionend", handleCompositionEnd);
    el == null ? void 0 : el.addEventListener(customEventName, handleInput);
    return () => {
      if (el) {
        el.removeEventListener("compositionstart", handleCompositionStart);
        el.removeEventListener("compositionend", handleCompositionEnd);
        el.removeEventListener(customEventName, handleInput);
      }
    };
  }, []);
  return /* @__PURE__ */ import_react.default.createElement("div", { className: `${clsPrefix}-input ${className}`, contentEditable: false }, prefix, /* @__PURE__ */ import_react.default.createElement(
    "div",
    {
      className: `${clsPrefix}-input__input-editor ${editorClassName}`,
      ref: editorRef,
      contentEditable: !disabled,
      onPaste: handlePaste,
      onKeyDown: handleKeydown,
      placeholder,
      onFocus,
      onBlur,
      ...{
        disabled
      },
      onSelectCapture: handleSelectCapture
    }
  ), suffix);
});
var HighlightInput_default = RichTextInput;
