import React from 'react';
import { Keywords, RichValue } from './types';
export declare function insertHtmlAtCaret(html: string, r?: Range): void;
export declare const makeKeywordsNodeString: (keywords: Keywords, keywordsStyle?: ((keywords: Keywords) => React.CSSProperties) | undefined) => string;
export declare function htmlEncode(s: string): string;
/**
 * 解析html，获取RichValue
 * @param html
 * @returns
 */
export declare const convertHTMLStringToRichValue: (html?: string) => RichValue;
/**
 * 将richValue还原成html字符串
 * @param richValue
 * @param rootNode contentEditable=true的节点
 * @returns
 */
export declare const convertRichValueToHTMLString: (richValue: RichValue, keywordsStyle?: ((keywords: Keywords) => React.CSSProperties) | undefined) => string;
