var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/HighlightInput/utils.ts
var utils_exports = {};
__export(utils_exports, {
  convertHTMLStringToRichValue: () => convertHTMLStringToRichValue,
  convertRichValueToHTMLString: () => convertRichValueToHTMLString,
  htmlEncode: () => htmlEncode,
  insertHtmlAtCaret: () => insertHtmlAtCaret,
  makeKeywordsNodeString: () => makeKeywordsNodeString
});
module.exports = __toCommonJS(utils_exports);
function insertHtmlAtCaret(html, r) {
  let range = r;
  let sel;
  if (window.getSelection) {
    sel = window.getSelection();
    if ((sel == null ? void 0 : sel.getRangeAt) && sel.rangeCount) {
      range = range || sel.getRangeAt(0).cloneRange();
      range == null ? void 0 : range.deleteContents();
      let el = document.createElement("div");
      el.innerHTML = html;
      let frag = document.createDocumentFragment(), node, lastNode;
      while (node = el.firstChild) {
        lastNode = frag.appendChild(node);
      }
      range == null ? void 0 : range.insertNode(frag);
      if (lastNode) {
        range = range == null ? void 0 : range.cloneRange();
        range == null ? void 0 : range.setStartAfter(lastNode);
        range == null ? void 0 : range.collapse(true);
        sel.removeAllRanges();
        sel.addRange(range);
      }
    }
  } else if (document.selection && document.selection.type !== "Control") {
    document.selection.createRange().pasteHTML(html);
  }
}
var kebabCase = (str) => {
  const regex = new RegExp(/[A-Z]/g);
  return str.replace(regex, (v) => `-${v.toLowerCase()}`);
};
var convertCssPropertiesToStyleString = (style) => {
  if (!style)
    return "";
  return Object.keys(style).reduce((accumulator, key) => {
    const cssKey = kebabCase(key);
    const cssValue = style[key].replace("'", "");
    return `${accumulator}${cssKey}:${cssValue};`;
  }, "");
};
function isIE() {
  let ua = window.navigator.userAgent;
  let msie = ua.indexOf("MSIE ");
  if (msie > 0) {
    return parseInt(ua.substring(msie + 5, ua.indexOf(".", msie)), 10);
  }
  let trident = ua.indexOf("Trident/");
  if (trident > 0) {
    let rv = ua.indexOf("rv:");
    return parseInt(ua.substring(rv + 3, ua.indexOf(".", rv)), 10);
  }
  let edge = ua.indexOf("Edge/");
  if (edge > 0) {
    return parseInt(ua.substring(edge + 5, ua.indexOf(".", edge)), 10);
  }
  return false;
}
var makeKeywordsNodeString = (keywords, keywordsStyle) => {
  var _a;
  const { label = "", value = "" } = keywords;
  const container = document.createElement("span");
  document.body.appendChild(container);
  const styles = keywordsStyle == null ? void 0 : keywordsStyle(keywords);
  const styleString = convertCssPropertiesToStyleString({
    ...styles,
    display: "inline-block"
  });
  container.innerText = label;
  container.setAttribute("style", styleString);
  const { width, height } = container.getBoundingClientRect();
  const src = [
    `data:image/svg+xml;charset=utf-8,<svg xmlns="http://www.w3.org/2000/svg" width="${width}px" height="${height}px">`,
    // 非IE用foreignobject
    (isIE() ? `<text x="50%" y="50%" dy=".5px" style="dominant-baseline:middle;text-anchor:middle;" font-size="${styles == null ? void 0 : styles.fontSize}" fill="${styles == null ? void 0 : styles.color}" font-family="${(_a = styles == null ? void 0 : styles.fontFamily) == null ? void 0 : _a.replace(
      // 把单双引号去掉，防止解析出错
      /['"]/g,
      ""
    )}">${label}</text>` : `<foreignObject x="0" y="0" width="${width}" height="${height}">
<body xmlns="http://www.w3.org/1999/xhtml" style="padding:0;margin:0;font-size:0">
${container.outerHTML}
</body>
</foreignObject>`).replace(/[\n\r]/g, ""),
    "</svg>"
  ].join("");
  const img = new Image();
  img.src = src;
  img.setAttribute("data-label", label);
  img.setAttribute("data-value", value);
  img.setAttribute("data-is-keywords", "true");
  img.setAttribute("data-keywords-info", JSON.stringify(keywords));
  container.remove();
  return img.outerHTML;
};
function filterRichValue(node, cbk) {
  var _a, _b, _c, _d, _e, _f, _g;
  if (node.nodeType === 3) {
    cbk(
      (_d = (_c = (_b = (_a = node == null ? void 0 : node.data) == null ? void 0 : _a.replace) == null ? void 0 : _b.call(_a, /[\n\r]/g, "")) == null ? void 0 : _c.replace(/\u00a0/g, " ")) == null ? void 0 : _d.replace(/&nbsp;/g, " "),
      node
    );
  } else if (node.nodeType === 1 && ((_e = node.dataset) == null ? void 0 : _e["isKeywords"]) === "true") {
    const info = node.dataset["keywordsInfo"];
    let v = {
      label: (_f = node.dataset) == null ? void 0 : _f.label,
      value: (_g = node.dataset) == null ? void 0 : _g.value
    };
    try {
      v = JSON.parse(info);
    } catch (e) {
      console.error(e);
    }
    cbk(v, node);
  } else {
    let i = 0, childNodes = node.childNodes, item, len = childNodes.length || 0;
    for (i; i < len; i++) {
      item = childNodes[i];
      filterRichValue(item, cbk);
    }
  }
}
function htmlEncode(s) {
  let str = s;
  if (!str || typeof str !== "string") {
    return str;
  }
  str = str.toString();
  return str.replace(/&/g, "&amp;").replace(/"/g, "&quot;").replace(/'/g, "&#39;").replace(/</g, "&lt;").replace(/>/g, "&gt;");
}
var convertHTMLStringToRichValue = (html) => {
  if (!html)
    return [];
  const tempDiv = document.createElement("div");
  tempDiv.innerHTML = html;
  let value = [];
  filterRichValue(tempDiv, (v) => {
    if (v) {
      value.push(v);
    }
  });
  return value;
};
var convertRichValueToHTMLString = (richValue, keywordsStyle) => {
  if (!(richValue == null ? void 0 : richValue.length))
    return "";
  let htmlString = "";
  for (let index = 0; index < richValue.length; index++) {
    const element = richValue[index];
    htmlString += typeof element === "string" ? htmlEncode(element).replace(/ /g, "&nbsp;") : makeKeywordsNodeString(element, keywordsStyle);
  }
  return htmlString;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  convertHTMLStringToRichValue,
  convertRichValueToHTMLString,
  htmlEncode,
  insertHtmlAtCaret,
  makeKeywordsNodeString
});
