var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/hooks/useControlValue.ts
var useControlValue_exports = {};
__export(useControlValue_exports, {
  default: () => useControlValue
});
module.exports = __toCommonJS(useControlValue_exports);
var import_react = require("react");
var import_useUpdate = __toESM(require("./useUpdate"));
function useControlValue(props, controlKeys = {
  valueKey: "value",
  defaultValueKey: "defaultValue",
  eventKey: "onChange"
}) {
  const { valueKey, defaultValueKey: defaultKey, eventKey } = controlKeys;
  const value = props[valueKey];
  const defaultValue = props[defaultKey];
  const onChange = props[eventKey];
  const update = (0, import_useUpdate.default)();
  const stateRef = (0, import_react.useRef)(
    value !== void 0 ? value : defaultValue
  );
  if (value !== void 0) {
    stateRef.current = value;
  }
  const setState = (0, import_react.useCallback)(
    (v, forceTrigger = false, ...args) => {
      const nextValue = typeof v === "function" ? v(stateRef.current) : v;
      if (!forceTrigger && nextValue === stateRef.current)
        return;
      stateRef.current = nextValue;
      update();
      return onChange == null ? void 0 : onChange(nextValue, ...args);
    },
    [onChange, update]
  );
  return [stateRef.current, setState];
}
