function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { forwardRef, useCallback, useEffect, useImperativeHandle, useRef } from 'react';
import useControlValue from "../hooks/useControlValue";
import "./index.scss";
import { convertHTMLStringToRichValue, convertRichValueToHTMLString, htmlEncode, insertHtmlAtCaret, makeKeywordsNodeString } from "./utils";
function trigger(el, type) {
  var e = document.createEvent('HTMLEvents');
  e.initEvent(type, true, true);
  el.dispatchEvent(e);
}
var RichTextInput = /*#__PURE__*/forwardRef(function (props, ref) {
  var disabled = props.disabled,
    placeholder = props.placeholder,
    _props$className = props.className,
    className = _props$className === void 0 ? '' : _props$className,
    _props$editorClassNam = props.editorClassName,
    editorClassName = _props$editorClassNam === void 0 ? '' : _props$editorClassNam,
    keywordsStyle = props.keywordsStyle,
    onFocus = props.onFocus,
    onBlur = props.onBlur,
    prefix = props.prefix,
    suffix = props.suffix;
  var _useControlValue = useControlValue(props),
    _useControlValue2 = _slicedToArray(_useControlValue, 2),
    value = _useControlValue2[0],
    setValue = _useControlValue2[1];
  var editorRef = useRef(null);
  var isComposing = useRef(false);
  var range = useRef();
  var handleChange = function handleChange(value) {
    var _window$getSelection;
    range.current = (_window$getSelection = window.getSelection()) === null || _window$getSelection === void 0 || (_window$getSelection = _window$getSelection.getRangeAt(0)) === null || _window$getSelection === void 0 ? void 0 : _window$getSelection.cloneRange();
    setValue(value);
  };
  var getKeywordsStyle = function getKeywordsStyle(keywords) {
    var rootStyle = editorRef.current && getComputedStyle(editorRef.current);
    var defaultStyle = {
      fontSize: rootStyle === null || rootStyle === void 0 ? void 0 : rootStyle.fontSize,
      fontFamily: rootStyle === null || rootStyle === void 0 ? void 0 : rootStyle.fontFamily,
      color: rootStyle === null || rootStyle === void 0 ? void 0 : rootStyle.color,
      wordBreak: 'keep-all',
      whiteSpace: 'nowrap',
      backgroundColor: 'rgba(194, 224, 255, 0.5)',
      lineHeight: rootStyle === null || rootStyle === void 0 ? void 0 : rootStyle.lineHeight,
      textAlign: 'center'
      // padding: '1px 0 1px 0'
    };

    var styles = _objectSpread({}, defaultStyle);
    if (typeof keywordsStyle === 'function') {
      styles = _objectSpread(_objectSpread({}, styles), keywordsStyle === null || keywordsStyle === void 0 ? void 0 : keywordsStyle(defaultStyle, keywords));
    } else {
      styles = _objectSpread(_objectSpread({}, styles), keywordsStyle);
    }
    return styles;
  };
  // 拦截粘贴，只允许粘贴文本
  var handlePaste = useCallback(function (e) {
    e.preventDefault();
    var clipboardData = e.clipboardData;
    var pastedText = (clipboardData || window.clipboardData).getData('text/html');
    if (pastedText) {
      // 不要换行符
      pastedText = pastedText.replace(/[\r\n]/g, '');
      // 去掉meta标签及换行,去掉内联样式
      var regex = /(<(meta|br).*?>)|(\sstyle=".*?")|(\n)/gi;
      pastedText = pastedText.replace(regex, '');
      // 尝试把复制的内容格式化成richValue
      var pastedRichValue = convertHTMLStringToRichValue(pastedText);
      var includeKeywords = pastedRichValue.find(function (item) {
        return typeof item !== 'string';
      });
      // 否则只留纯文本
      if (!includeKeywords) {
        pastedText = htmlEncode((clipboardData || window.clipboardData).getData('text/plain'));
        pastedRichValue = convertHTMLStringToRichValue(pastedText);
      }
      if (editorRef.current) {
        pastedText = convertRichValueToHTMLString(pastedRichValue, getKeywordsStyle);
        document.execCommand('insertHTML', false, pastedText);
        var richValue = convertHTMLStringToRichValue(editorRef.current.innerHTML);
        handleChange(richValue);
      }
    }
    return false;
  }, [setValue]);
  var handleKeydown = useCallback(function (e) {
    // 防止输入换行
    if (e.key === 'Enter') {
      e.preventDefault();
    }
  }, []);
  useImperativeHandle(ref, function () {
    return {
      insertKeywords: function insertKeywords(keywords) {
        var _editorRef$current;
        if (!editorRef.current) {
          return;
        }
        var keywordsNodeString = makeKeywordsNodeString(keywords, getKeywordsStyle);
        (_editorRef$current = editorRef.current) === null || _editorRef$current === void 0 || _editorRef$current.focus();
        insertHtmlAtCaret(keywordsNodeString, range.current);
        var richValue = convertHTMLStringToRichValue(editorRef.current.innerHTML);
        handleChange(richValue);
      }
    };
  });
  var handleSelectCapture = useCallback(function () {
    var _window$getSelection2;
    range.current = (_window$getSelection2 = window.getSelection()) === null || _window$getSelection2 === void 0 || (_window$getSelection2 = _window$getSelection2.getRangeAt(0)) === null || _window$getSelection2 === void 0 ? void 0 : _window$getSelection2.cloneRange();
  }, []);
  var clsPrefix = 'c-highlight';
  useEffect(function () {
    var _editorRef$current$in;
    if (!editorRef.current) {
      return;
    }
    var htmlString = convertRichValueToHTMLString(value, getKeywordsStyle);
    var innerHtmlString = (_editorRef$current$in = editorRef.current.innerHTML) === null || _editorRef$current$in === void 0 ? void 0 : _editorRef$current$in.replace(/&nbsp;/g, ' ');
    var innerValue = convertHTMLStringToRichValue(innerHtmlString) || [];
    var isEqual = true;
    if (innerValue.length !== (value === null || value === void 0 ? void 0 : value.length)) {
      isEqual = false;
    } else {
      for (var index = 0; index < innerValue.length; index++) {
        var element = innerValue[index];
        var receivedElement = value === null || value === void 0 ? void 0 : value[index];
        if (typeof element === 'string' || typeof receivedElement === 'string') {
          if (element !== receivedElement) {
            isEqual = false;
            break;
          }
        } else {
          if (element.value !== receivedElement.value && element.label !== receivedElement.label) {
            isEqual = false;
          }
        }
      }
    }
    if (!isEqual) {
      editorRef.current.innerHTML = htmlString;
    }
  }, [value]);
  useEffect(function () {
    var el = editorRef.current;
    var customEventName = 'input';
    var handleCompositionStart = function handleCompositionStart() {
      isComposing.current = true;
    };
    var handleCompositionEnd = function handleCompositionEnd(e) {
      if (!isComposing.current) return;
      isComposing.current = false;
      trigger(e.target, customEventName);
    };
    var handleInput = function handleInput(e) {
      if (isComposing.current) return;
      var innerHTML = e.currentTarget.innerHTML;
      var richValue = convertHTMLStringToRichValue(innerHTML);
      handleChange(richValue);
    };
    el === null || el === void 0 || el.addEventListener('compositionstart', handleCompositionStart);
    el === null || el === void 0 || el.addEventListener('compositionend', handleCompositionEnd);
    // el?.addEventListener("change", handleCompositionEnd);
    el === null || el === void 0 || el.addEventListener(customEventName, handleInput);
    return function () {
      if (el) {
        el.removeEventListener('compositionstart', handleCompositionStart);
        el.removeEventListener('compositionend', handleCompositionEnd);
        // el.removeEventListener("change", handleCompositionEnd);
        el.removeEventListener(customEventName, handleInput);
      }
    };
  }, []);
  return /*#__PURE__*/React.createElement("div", {
    className: "".concat(clsPrefix, "-input ").concat(className),
    contentEditable: false
  }, prefix, /*#__PURE__*/React.createElement("div", {
    className: "".concat(clsPrefix, "-input__input-editor ").concat(editorClassName),
    ref: editorRef,
    contentEditable: !disabled,
    onPaste: handlePaste,
    onKeyDown: handleKeydown,
    placeholder: placeholder,
    onFocus: onFocus,
    onBlur: onBlur,
    disabled: disabled,
    onSelectCapture: handleSelectCapture
  }), suffix);
});
export default RichTextInput;