function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
export function insertHtmlAtCaret(html, r) {
  var range = r;
  var sel;
  if (window.getSelection) {
    var _sel;
    // IE9 and non-IE
    sel = window.getSelection();
    if ((_sel = sel) !== null && _sel !== void 0 && _sel.getRangeAt && sel.rangeCount) {
      var _range, _range2;
      range = range || sel.getRangeAt(0).cloneRange();
      (_range = range) === null || _range === void 0 || _range.deleteContents();
      // Range.createContextualFragment() would be useful here but is
      // non-standard and not supported in all browsers (IE9, for one)
      var el = document.createElement('div');
      el.innerHTML = html;
      var frag = document.createDocumentFragment(),
        node,
        lastNode;
      while (node = el.firstChild) {
        lastNode = frag.appendChild(node);
      }
      (_range2 = range) === null || _range2 === void 0 || _range2.insertNode(frag);
      // Preserve the selection
      if (lastNode) {
        var _range3, _range4, _range5;
        range = (_range3 = range) === null || _range3 === void 0 ? void 0 : _range3.cloneRange();
        (_range4 = range) === null || _range4 === void 0 || _range4.setStartAfter(lastNode);
        (_range5 = range) === null || _range5 === void 0 || _range5.collapse(true);
        sel.removeAllRanges();
        sel.addRange(range);
      }
    }
  } else if (document.selection && document.selection.type !== 'Control') {
    // IE < 9
    document.selection.createRange().pasteHTML(html);
  }
}
var kebabCase = function kebabCase(str) {
  var regex = new RegExp(/[A-Z]/g);
  return str.replace(regex, function (v) {
    return "-".concat(v.toLowerCase());
  });
};
var convertCssPropertiesToStyleString = function convertCssPropertiesToStyleString(style) {
  if (!style) return '';
  return Object.keys(style).reduce(function (accumulator, key) {
    // transform the key from camelCase to kebab-case
    var cssKey = kebabCase(key);
    // remove ' in value
    var cssValue = style[key].replace("'", '');
    // build the result
    // you can break the line, add indent for it if you need
    return "".concat(accumulator).concat(cssKey, ":").concat(cssValue, ";");
  }, '');
};
function isIE() {
  var ua = window.navigator.userAgent;

  // Test values; Uncomment to check result …

  // IE 10
  // ua = 'Mozilla/5.0 (compatible; MSIE 10.0; Windows NT 6.2; Trident/6.0)';

  // IE 11
  // ua = 'Mozilla/5.0 (Windows NT 6.3; Trident/7.0; rv:11.0) like Gecko';

  // Edge 12 (Spartan)
  // ua = 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.71 Safari/537.36 Edge/12.0';

  // Edge 13
  // ua = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/46.0.2486.0 Safari/537.36 Edge/13.10586';

  var msie = ua.indexOf('MSIE ');
  if (msie > 0) {
    // IE 10 or older => return version number
    return parseInt(ua.substring(msie + 5, ua.indexOf('.', msie)), 10);
  }
  var trident = ua.indexOf('Trident/');
  if (trident > 0) {
    // IE 11 => return version number
    var rv = ua.indexOf('rv:');
    return parseInt(ua.substring(rv + 3, ua.indexOf('.', rv)), 10);
  }
  var edge = ua.indexOf('Edge/');
  if (edge > 0) {
    // Edge (IE 12+) => return version number
    return parseInt(ua.substring(edge + 5, ua.indexOf('.', edge)), 10);
  }

  // other browser
  return false;
}
export var makeKeywordsNodeString = function makeKeywordsNodeString(keywords, keywordsStyle) {
  var _styles$fontFamily;
  var _keywords$label = keywords.label,
    label = _keywords$label === void 0 ? '' : _keywords$label,
    _keywords$value = keywords.value,
    value = _keywords$value === void 0 ? '' : _keywords$value;
  var container = document.createElement('span');
  document.body.appendChild(container);
  var styles = keywordsStyle === null || keywordsStyle === void 0 ? void 0 : keywordsStyle(keywords);
  var styleString = convertCssPropertiesToStyleString(_objectSpread(_objectSpread({}, styles), {}, {
    display: 'inline-block'
  }));
  container.innerText = label;
  container.setAttribute('style', styleString);
  // 测量宽高
  var _container$getBoundin = container.getBoundingClientRect(),
    width = _container$getBoundin.width,
    height = _container$getBoundin.height;
  var src = ["data:image/svg+xml;charset=utf-8,<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"".concat(width, "px\" height=\"").concat(height, "px\">"),
  // 非IE用foreignobject
  (isIE() ? "<text x=\"50%\" y=\"50%\" dy=\".5px\" style=\"dominant-baseline:middle;text-anchor:middle;\" font-size=\"".concat(styles === null || styles === void 0 ? void 0 : styles.fontSize, "\" fill=\"").concat(styles === null || styles === void 0 ? void 0 : styles.color, "\" font-family=\"").concat(styles === null || styles === void 0 || (_styles$fontFamily = styles.fontFamily) === null || _styles$fontFamily === void 0 ? void 0 : _styles$fontFamily.replace(
  // 把单双引号去掉，防止解析出错
  /['"]/g, ''), "\">").concat(label, "</text>") : "<foreignObject x=\"0\" y=\"0\" width=\"".concat(width, "\" height=\"").concat(height, "\">\n<body xmlns=\"http://www.w3.org/1999/xhtml\" style=\"padding:0;margin:0;font-size:0\">\n").concat(container.outerHTML, "\n</body>\n</foreignObject>")).replace(/[\n\r]/g, ''), '</svg>'].join('');
  var img = new Image();
  img.src = src;
  img.setAttribute('data-label', label);
  img.setAttribute('data-value', value);
  img.setAttribute('data-is-keywords', 'true');
  img.setAttribute('data-keywords-info', JSON.stringify(keywords));
  container.remove();
  return img.outerHTML;
};
function filterRichValue(node, cbk) {
  var _node$dataset;
  // 文本节点
  if (node.nodeType === 3) {
    var _node$data, _node$data$replace;
    cbk(node === null || node === void 0 || (_node$data = node.data) === null || _node$data === void 0 || (_node$data$replace = _node$data.replace) === null || _node$data$replace === void 0 || (_node$data$replace = _node$data$replace.call(_node$data, /[\n\r]/g, '')) === null || _node$data$replace === void 0 || (_node$data$replace = _node$data$replace.replace(/\u00a0/g, ' ')) === null || _node$data$replace === void 0 ? void 0 : _node$data$replace.replace(/&nbsp;/g, ' '), node);
  }
  // 字段节点
  else if (node.nodeType === 1 && ((_node$dataset = node.dataset) === null || _node$dataset === void 0 ? void 0 : _node$dataset['isKeywords']) === 'true') {
    var _node$dataset2, _node$dataset3;
    var info = node.dataset['keywordsInfo'];
    var _v = {
      label: (_node$dataset2 = node.dataset) === null || _node$dataset2 === void 0 ? void 0 : _node$dataset2.label,
      value: (_node$dataset3 = node.dataset) === null || _node$dataset3 === void 0 ? void 0 : _node$dataset3.value
    };
    try {
      _v = JSON.parse(info);
    } catch (e) {
      console.error(e);
    }
    cbk(_v, node);
  }
  // 查找下一个节点
  else {
    var i = 0,
      childNodes = node.childNodes,
      item,
      len = childNodes.length || 0;
    for (i; i < len; i++) {
      item = childNodes[i];
      filterRichValue(item, cbk);
    }
  }
}
export function htmlEncode(s) {
  var str = s;
  if (!str || typeof str !== 'string') {
    return str;
  }
  str = str.toString();
  return str.replace(/&/g, '&amp;').replace(/"/g, '&quot;').replace(/'/g, '&#39;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
}

/**
 * 解析html，获取RichValue
 * @param html
 * @returns
 */
export var convertHTMLStringToRichValue = function convertHTMLStringToRichValue(html) {
  if (!html) return [];
  var tempDiv = document.createElement('div');
  tempDiv.innerHTML = html;
  var value = [];
  filterRichValue(tempDiv, function (v) {
    if (v) {
      value.push(v);
    }
  });
  return value;
};

/**
 * 将richValue还原成html字符串
 * @param richValue
 * @param rootNode contentEditable=true的节点
 * @returns
 */
export var convertRichValueToHTMLString = function convertRichValueToHTMLString(richValue, keywordsStyle) {
  if (!(richValue !== null && richValue !== void 0 && richValue.length)) return '';
  var htmlString = '';
  for (var index = 0; index < richValue.length; index++) {
    var element = richValue[index];
    htmlString += typeof element === 'string' ? htmlEncode(element).replace(/ /g, '&nbsp;') : makeKeywordsNodeString(element, keywordsStyle);
  }
  return htmlString;
};