import { SetStateAction } from 'react';
type Props<T> = {
    value?: T;
    defaultValue?: T;
    onChange?: (v: T) => void;
};
/**
 * 用于实现受控与非受控特性
 * @param props
 * @param controlKeys
 * @returns
 */
export default function useControlValue<V, T extends Props<V>>(props: T, controlKeys?: {
    valueKey: keyof T;
    defaultValueKey: keyof T;
    eventKey: keyof T;
}): readonly [V, (v: SetStateAction<V>, forceTrigger?: boolean, ...args: any[]) => any];
export {};
